/*
c++ -Iinclude -std=c++14 -o tst-xapian_remote .libs/libxapian-1.5.so -Wl,-rpath ~+/.libs -pthread tst-xapian_remote.cc && ./tst-xapian_remote
*/

#include <iostream>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <thread>

#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <xapian.h>

constexpr const int port = 5050;

int main() {
	char buf[80];
	{
		int fd = dup(1);
		std::cerr << "First unused fd = " << fd << std::endl;
		close(fd);
		sprintf(buf, "%ld", (long)getpid());
		system(("ls -l /proc/" + std::string(buf) + "/fd").c_str());
		try {
			auto wsdb = Xapian::Remote::open_writable("localhost", port, 1000, 1000, Xapian::DB_CREATE_OR_OPEN);
			std::cerr << "Opened OK" << std::endl;
		} catch (const Xapian::Error& exc) {
			std::cerr << exc.get_description() << std::endl;
		}
	}

	int fd = dup(1);
	std::cerr << "First unused fd = " << fd << std::endl;
	close(fd);
	sprintf(buf, "%ld", (long)getpid());
	system(("ls -l /proc/" + std::string(buf) + "/fd").c_str());

	return 0;
}
